/* prof. Emanuela Cerchez, Liceul de Informatica "Grigore Moisil" Iasi */
#include <stdio.h>
#define DimMaxParc 177
#define DimMaxCoada 30625

//deplasarile pe linie si coloana pe directiile N,E,S,V}
const int dx[5] = {0, -1, 0, 1, 0};
const int dy[5] = {0, 0, 1, 0, -1};

typedef struct
           {
             unsigned char l, c; //pozitia in Parc
           }Element;

typedef Element Coada[DimMaxCoada];

int A[DimMaxParc][DimMaxParc];
/*
A[i][j]=-1 daca in pozitia i,j se afla un copac
A[i][j]=-2 daca zona i,j este libera
A[i][j]=d, daca zona i,j este este libera situata la distanta d de prima poarta
*/

int ix, iy, ox, oy;
int n, m;
int NrDale;


void Citire(void)
{
  int k, i, j;

  FILE * Fin=freopen("alee.in", "r", stdin);

  scanf("%d%d", &n, &m); //citesc dimensiunile parcului si numarul de pomi
  //marchez cu -2 pozitiile libere
  for (i=1; i<=n; i++)
    for (j=1; j<=n; j++) A[i][j] = -2;
  for (k=1; k<=m; k++)
    {
      scanf("%d %d", &i, &j); //citesc coordonatele obstacolelor
      A[i][j] = -1;           //marchez obstacolele cu -1
    }
  //citesc pozitiile portii de intrare si de iesire
  scanf("%d %d %d %d", &ix, &iy, &ox, &oy);
  fclose(Fin);
}

void Bordare(void)
{
  //bordez parcul cu pomi}
  int i, j;
  for (i=1; i<=n; i++)
    {A[i][0] = -1;A[i][n+1] = -1;
     A[0][i] = -1;A[n+1][i] = -1;}
}

void DeterminNrDale(void)
{
  Coada C;
  int IncC, SfC, k;    //inceputul si sfarsitul cozii
  Element x, y;

  //initializez coada
  x.l = ix; x.c = iy; A[ix][iy] = 1;
  //pun pozitia initiala, poarta de intrare, in coada}
  IncC = SfC = 0; C[IncC] = x;
  //parcurg parcul
  while (IncC <=SfC && A[ox][oy]==-2)
    {
      //extrag un element din coada
      x = C[IncC++];
      //ma deplasez in cele patru directii posibile
      for (k=1; k<=4; k++)
        {
          y.l = x.l + dx[k];  y.c = x.c + dy[k];
          //y - urmatoarea pozitie in directia k
          if (A[y.l][y.c]==-2)
          //y- pozitie libera cu distanta minima necalculata
            {
             A[y.l][y.c] = A[x.l][x.c]+1;
              //inserez pozitia y in coada
              C[++SfC] =y;

            }
        }
    }
   if (A[ox][oy]==-2) printf("Nu exista solutie\n");
      else NrDale=A[ox][oy];

}

void Afisare(void)
{
  //afisez solutia
  FILE * Fout=freopen("alee.out", "w", stdout);
  printf("%d\n", NrDale);
  fclose(Fout);
}

void main(void)
{
  Citire();
  Bordare();
  DeterminNrDale();
  Afisare();
}
