{prof. Marinel Serban, Liceul de Informatica Grigore Moisil Iasi}
{$M 65520,0,655360}
Program alee;
Const DimMaxParc = 176;
      DimMaxCoada = 16000;
      dx: Array[1 .. 4] Of -1 .. 1 = (-1, 0, 1, 0);
      dy: Array[1 .. 4] Of -1 .. 1 = (0, 1, 0, -1);
      InFile='alee.in';
      OutFile='alee.out';
{deplasarile pe linie si coloana pe directiile N,E,S,V}
type  Indice = 0 .. DimMaxParc + 1;
      Element = Record
                 l, c: Indice;         {pozitia in Parc}
                 d: Word;              {distanta minima pana la pozitia l,c}
                End;
      IndiceC = 0 .. DimMaxCoada;
      Coada = Array[IndiceC] Of Element;
Var A: Array[Indice, Indice] Of integer;
    n, ix, iy, ox, oy: Indice;
    m: Word;
    Fin, Fout: text;  {fisierele de intrare si de iesire}
    NrDale: LongInt;

Procedure CautaAlee;
{determin in parc o alee - plec de la iesire}
Var C: Coada;
    IncC, SfC, k: IndiceC;    {inceputul si sfarsitul cozii}
    x, y: Element;
Begin
{initializez coada cu coordonatele portii de iesire}
  x.l := ox; x.c := oy; x.d := NrDale-1;
{pun pozitia initiala, poarta de iesire, in coada}
  IncC := 1;  SfC := 1; C[IncC]:=x;
{parcurg aleea inapoi}
  While IncC <= SfC Do
    Begin
      {extrag un element din coada}
      x := C[IncC]; inc(IncC);
      {ma deplasez in cele patru directii posibile}
      For k := 1 To 4 Do
        Begin
          {y - urmatoarea pozitie in directia k}
          y.l := x.l + dx[k];  y.c := x.c + dy[k];
         {y- sunt pe alee pe urmatoarea dala, cu 1 mai mic decat precedenta}
          If A[y.l, y.c] = x.d-1 Then
            Begin
              A[x.l, x.c] := 0; y.d := x.d-1;
              {inserez pozitia y in coada}
              Inc(SfC); C[SfC]:= y;
              Break
            End
        End;
      End;
End;

Procedure Citire;
Var k: IndiceC;
    i, j: Indice;
Begin
  Assign(Fin, InFile); Reset(Fin);             {citire}
  ReadLn(Fin, n, m); {citesc dimensiunile parculuisi numarul de pomi}
{marchez cu -2 pozitiile libere}
  For i := 1 To n Do
    For j := 1 To n Do A[i, j] := -2;
  For k := 1 To m Do
    Begin
      ReadLn(Fin, i, j); {citesc coordonatele obstacolelor}
      if (A[i,j]=-1) then writeln('2 copaci in pozitia ', i, ' ', j);
      A[i, j] := -1;            {marchez obstacolele cu -1}
    End;
{citesc pozitiile portii de intrare si de iesire}
  ReadLn(Fin, ix, iy, ox, oy);
  if A[ix,iy]=-1 then    writeln('pozitia ', ix, ' ', iy, ' ocupata');
  if A[ox,oy]=-1 then    writeln('pozitia ', ox, ' ', oy, ' ocupata');
  Close(Fin);
End;

Procedure Bordare;
{bordez parcul cu pomi}
Var i, j: Indice;
Begin
  For i := 1 To n Do
    Begin
      A[i,0] := -1;
      A[i,n+1] := -1
    End;
  For i := 1 To n Do
    Begin
      A[0,i] := -1;
      A[n+1,i] := -1
    End;
End;

Procedure DeterminNrDale;
Var C: Coada;
    IncC, SfC, k: IndiceC;    {inceputul si sfarsitul cozii}
    x, y: Element;
    NrElemInCoada: Word;
Begin
{initializez coada}
  x.l := ix; x.c := iy; x.d := 0; A[ix, iy] := 0;
{pun pozitia initiala, poarta de intrare, in coada}
  IncC := 1;  SfC := 1; C[IncC]:=x;
  NrElemInCoada := 1;
{parcurg parcul}
  While (IncC <= SfC) Or (NrElemInCoada>0) Do
    Begin
      {extrag un element din coada}
      x := C[IncC]; Inc(IncC); Dec(NrElemInCoada);
      If (IncC=DimMaxCoada+1) And (NrElemInCoada>0) Then
        IncC := 1;
      {ma deplasez in cele patru directii posibile}
      For k := 1 To 4 Do
        Begin
          y.l := x.l + dx[k];  y.c := x.c + dy[k];
          {y - urmatoarea pozitie in directia k}
          If A[y.l, y.c] = -2 Then
         {y- pozitie libera cu distanta minima necalculata}
            Begin
              y.d := x.d + 1; A[y.l, y.c] := y.d;
              {inserez pozitia y in coada}
              Inc(SfC);
              If (SfC=DimMaxCoada+1) Then
                SfC := 1;
              C[SfC]:= y; Inc(NrElemInCoada)
            End
        End;
      End;
End;

Procedure Afisare;
{afisez solutia}
Var i, j: Indice;
Begin
  Assign(Fout, OutFile); ReWrite(Fout);
  WriteLn(Fout, NrDale);
  {
  For i := 1 To n Do
     Begin
       For j := 1 To n Do
         Case A[i, j] Of
           -1: Write(Fout, 'X');
            0: Write(Fout, 'O');
            Else
               Write(Fout, '-');
         End;
       WriteLn(Fout)
     End;
  }
  Close(Fout)
End;

Begin
  Citire;
  Bordare;
  DeterminNrDale;
  NrDale := A[ox, oy]+1; {numarul de dale utilizat}
  CautaAlee;
  Afisare;
End.
