Program cartele;
const DIM = 51;
var fin, fout : text;
    a, b, aux : array[1..DIM, 1..DIM] of integer;
    n, C : integer;

function  Egale : boolean;
var i, j : integer;
    eq : boolean;
begin
    i := 1; eq := true;
 	while (i <= n) and eq do
        begin
            j := 1;
            while (j <= n) and eq do
               begin
                   if a[i,j] <> b[i,j] then eq := false;
                   inc(j);
               end;
            inc(i);
        end;
    Egale := eq
end;

procedure Inverseaza;            { intoarce cartela pe partea cealalta (oglindire fata de linia i = n/2)}
var i, j, temp : integer;
begin
    for i := 1 to n div 2 do
        for j := 1 to n do
            begin
               temp := b[i,j]; b[i,j] := b[n-i+1,j];
               b[n-i+1,j] := temp;
            end
end;

procedure Roteste;
var i, j : integer;
begin
    for i := 1 to n do
        for j := 1 to n do
            aux[n-j+1,i] := b[i,j];

    for i := 1 to n do
        for j := 1 to n do
            b[i,j] := aux[i,j];
end;

procedure Rezolva;
var i, j, k, r, f : integer;
    identice : boolean;
begin
    assign(fin, 'cartele.in'); reset(fin);
    assign(fout, 'cartele.out'); rewrite(fout);
    readln(fin, n, C);

    identice := true;
    for i := 1 to n do
        for j := 1 to n do
            read(fin, a[i,j]);

    for k := 1 to C do
        begin
            identice := true;
            for i := 1 to n do
                for j := 1 to n do
                    begin
                        read(fin, b[i,j]);
                        if b[i,j] <> a[i,j] then identice := false
                    end;

            f := 1;
            while  (f <= 2) and not identice do
                begin
                    r := 1;
                    while (r <= 4) and not identice do  { la a patra rotatie se revine la matricea initiala}
                         begin
                             Roteste;    { cu 90 in sens trigonometric}
                             if  Egale then  identice := true;
                             inc(r);
                         end;
                    if  not identice then Inverseaza;
                    inc(f);
                end;
            if  identice then
                writeln(fout, 1)
            else
                writeln(fout, 0)
        end
end;

begin
    Rezolva;
    close(fin);
    close(fout);
end.
